////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////
// STRINGS HERE:
STRING* explosion_pcx = "models/explo+9.pcx";
STRING* explosion_tga = "models/explo+20.tga";
STRING* burn_tga = "models/burn.tga";
////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////
// SOUNDS HERE:
SOUND* explo_wav = "sounds/explode.wav"; 
////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////
// BMAPS HERE:
BMAP* smoke_tga = "models/smoke.tga";

BMAP* fire_map="models/fire1.tga";
BMAP* smoke_map="models/smoke.tga";
////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////
// PARTICLES HERE:
function handle_size(ENTITY* ent, X, Y, Z)
{
	ent.scale_x = X;
	ent.scale_y = Y;
	ent.scale_z = Z;
}
function fire_fade(PARTICLE* p){
	p.size-=2*time_step;
	p.x+=random (1.5*(sin(total_ticks*200) * cos(total_ticks*50)));
	p.y+=random (1.5*(sin(total_ticks*200) * sin(total_ticks*50)));
	p.z+=random (1.5*(sin(total_ticks*200) * sin(total_ticks*50)));
}
function firetrail_particle(PARTICLE* p) {
	p.size = 60.000;
	p.alpha = 100.000;
	p.red = 255;
	p.green = 128;
	p.blue = 64;
	p.skill_c = 0.5;
	p.vel_x = random(20.000)+(-10.000);
	p.vel_y = random(10.000)+(-10.000);
	p.vel_z = (1.000);
	p.lifespan = 2.000;
	p.gravity = 0.000;
	p.bmap = fire_map;
	p.flags = BRIGHT | TRANSLUCENT | MOVE | BEAM;
	p.skill_x = p.vel_x;
	p.skill_y = p.vel_y;
	p.skill_z = p.vel_z;
	p.event = fire_fade;
}
function smoke_particle(PARTICLE* p) {
	p.size = 60.000;
	p.alpha = 100.000;
	//p.red = 255;
	//p.green = 128;
	//p.blue = 64;
	//vec_set(p.blue,vector(random(100),random(100),random(100)));
	p.skill_c = 0.5;
	p.vel_x = random(20.000)+(-10.000);
	p.vel_y = random(10.000)+(-10.000);
	p.vel_z = (1.000);
	p.lifespan = 2.000;
	p.gravity = 0.000;
	p.bmap = smoke_map;
	p.flags =  TRANSLUCENT | MOVE | BEAM;//BRIGHT | 
	p.skill_x = p.vel_x;
	p.skill_y = p.vel_y;
	p.skill_z = p.vel_z;
	p.event = fire_fade;
}
function dead_particle(PARTICLE* p) {
	p.size = 60.000;
	p.alpha = 100.000;
	p.red = 100;
	p.green = 100;
	p.blue = 100;
	p.skill_c = 0.5;
	p.vel_x = random(20.000)+(-10.000);
	p.vel_y = random(10.000)+(-5.000);
	p.vel_z = (1.000);
	p.lifespan = 20.000;
	p.gravity = 0.000;
	p.bmap = smoke_map;
	p.flags =  TRANSLUCENT | MOVE | BEAM;//BRIGHT |
	p.skill_x = p.vel_x;
	p.skill_y = p.vel_y;
	p.skill_z = p.vel_z;
	p.event = fire_fade;
}
function loose_smoke(PARTICLE* p)
{
	p.alpha -= 1 * time_step;	
	p.size += 1 * time_step;
	if(p.alpha <= 1){p.lifespan = 0;}  
}
function smoke_effect(PARTICLE *p)
{
	p.size = 6;   
	p->vel_x = 0.3 - random(0.6);
	p->vel_y = 0.3 - random(0.6);
	p->vel_z = 0.3 - random(0.6);
	p.alpha = 5 + random(10);
	p.bmap = smoke_tga;
	p.flags |= (MOVE | BRIGHT);
	p.event = loose_smoke;
}
////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////
// EFFECT FUNCTIONS HERE:
function big_burn()
{
	handle_size(my,2,2,2);
	c_trace(my.x,vector(my.x,my.y,my.z-1000),IGNORE_ME|IGNORE_SPRITES|IGNORE_MODELS);  
	my.z = hit.z + 0.4;						
	my.alpha = 70;
	set(my,PASSABLE|TRANSLUCENT|FLAG2);
	my.pan = random(360);
	while(my.alpha > 0)
	{
		my.tilt = -90;
		my.alpha -= 0.5 * time_step;		
		wait(1);	
	}
	wait(1);
	ent_remove(my);
}
function tank_explosion()
{
	my.roll = random(360);
	handle_size(my,1.5,1.5,1.5);
	set(my,PASSABLE|BRIGHT|TRANSLUCENT|UNLIT|FLAG2);
	my.alpha = 100;
	while(my.frame < 9)	
	{
		my.alpha -= 1 * time_step;
		my.frame += 1*time_step;		
		wait(1);	
	}
	my.frame = 0;	
	wait(1);
	ent_remove(my);
}
function big_explosion()
{
	my.roll = random(360);
	handle_size(my,8,8,8);
	set(my,PASSABLE|BRIGHT|TRANSLUCENT|UNLIT|FLAG2);
	my.alpha = 100;
	while(my.frame < 20)	
	{
		my.alpha -= 1 * time_step;
		my.frame += 1*time_step;		
		wait(1);	
	}
	my.frame = 0;	
	wait(1);
	ent_remove(my);
}
function small_explosion()
{
	my.roll = random(360);
	handle_size(my,2,2,2);
	set(my,PASSABLE|BRIGHT|TRANSLUCENT|UNLIT|FLAG2);
	my.alpha = 100;
	while(my.frame < 20)	
	{
		my.alpha -= 1 * time_step;
		my.frame += 2*time_step;		
		wait(1);	
	}
	my.frame = 0;	
	wait(1);
	ent_remove(my);
}
////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////